local shortName,N = ...
----------------
-- File globals
----------------
local select, LibStub
    = select, LibStub

local A = LibStub("Abacus-1.0")
local D = LibStub("DoomCore-2.0")
local updateFrame, setFont = D.updateFrame, D.setFont
local setFrameEnabled = A.setFrameEnabled
N.updateFrame = updateFrame
local Addon = D.Addon(shortName, "Conversation", N)
Addon.version = 0.1

local lsm = LibStub("LibSharedMedia-3.0")

local head = Conversation

--------
-- Core
--------

function Addon:OnInitialize()
  self:Register(nil, "Default")
  lsm:RegisterCallback("LibSharedMedia_Registered", function()
    self:Rebuild()
  end)

  setFrameEnabled("QuestFrame", false)
  setFrameEnabled("GossipFrame", false)
  setFrameEnabled("QuestInfoFrame", false)
  setFrameEnabled("QuestInfoRewardsFrame", false)
end

function Addon:OnLoad()
  self:Rebuild()
end


------------------
-- Frames
------------------

function Addon:BuildChoice(choice, conf)
  conf = conf or self.core
  setFont(choice.TextFrame.Text, {
    font = conf.choiceFont,
    fontSize = conf.choiceSize
  })
  setFont(choice.TextFrame.TextVirtual, {
    font = conf.choiceFont,
    fontSize = conf.choiceSize
  })
end

function Addon:Rebuild(info, r, g, b, a)
  if info then self:ConfSet(info, r, g, b, a) end
  setFrameEnabled("ItemTextFrame", not self.core.read)
  local conf = self.core
  head.TextFrame.Progress:GetAnimations():SetDuration(conf.slideSpeed)
  updateFrame(head,conf)
  head:AnchorAlerts(conf)
  setFont(head.NameFrame.Name, {
    font = conf.titleFont,
    fontSize = conf.titleSize
  })
  setFont(head.TextFrame.Text, {
    font = conf.textFont,
    fontSize = conf.textSize
  })
  for i=1,select("#", head.ChoicesFrame:GetChildren()) do
    self:BuildChoice(select(i, head.ChoicesFrame:GetChildren()), conf)
  end
end

function Addon:Close()
  self:Output("Closing")
  head:Close()
end